{$A+,B-,D+,E+,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 65520,0,655360}

const
  fin = 'zad4.dat';
  fout = 'zad4.res';
  maxN = 9;
  maxM = 10;
  inf = 10000;

type
  TCond = record
            p : Integer;
            k : Word;
            s : array [1..maxN] of Word;
          end;

  TConds = array [1..maxM] of TCond;

var
  letters : array[1..maxN] of Char;
  n, m : Word;
  conds : TConds;
  maxScore : Integer;


  function FindLetter(l : Char) : Word;
  var
    i : Word;
  begin
    i := 1;
    while l <> letters[i] do
      inc(i);
    FindLetter := i;
  end;


  procedure ReadInput;
  var
    f : Text;
    i, j : Word;
    l : Char;
  begin
    Assign(f, fin);
    Reset(f);
    Read(f, n, l);
    for i := 1 to n do
      Read(f, letters[i]);

    Read(f, m);
    for i := 1 to m do
    begin
      Read(f, conds[i].p, conds[i].k, l);
      for j := 1 to conds[i].k do
      begin
        Read(f, l);
        conds[i].s[j] := FindLetter(l);
      end;
    end;
    Close(f);
  end;


  procedure WriteOutput;
  var
    f : Text;
  begin
    Assign(f, fout);
    Rewrite(f);
    WriteLn(f, maxScore);
    Close(f);
  end;


  procedure Solve;
  var
    p : array [1..maxN] of Word;

    procedure Test;
    var
      i, j : Word;
      score : Integer;
    begin
      score := 0;
      for i := 1 to m do
      begin
        j := 2;
        while (j <= conds[i].k) and (p[conds[i].s[j - 1]] < p[conds[i].s[j]]) do
          Inc(j);
        if j > conds[i].k then
          score := score + conds[i].p;
      end;
      if score > maxScore then
        maxScore := score;
    end;

    procedure Permute(k : Word);
    var
      i : Word;
      t : Word;
    begin
      if k = 1 then
        Test
      else
      begin
        t := p[k];
        for i := 1 to k do
        begin
          p[k] := p[i];
          p[i] := t;
          Permute(k-1);
          p[i] := p[k];
        end;
      end;
    end;

  var
    i : Word;
  begin
    maxScore := -inf;
    for i := 1 to n do
      p[i] := i;
    Permute(n);
  end;

begin
  ReadInput;
  Solve;
  WriteOutput;
end.
